diff -u dstat-0.6.7/debian/changelog dstat-0.6.7/debian/changelog
--- dstat-0.6.7/debian/changelog
+++ dstat-0.6.7/debian/changelog
@@ -1,3 +1,9 @@
+dstat (0.6.7-1lenny1) stable-security; urgency=high
+
+  * Add patch from Nico Golde to address CVE-2009-3894 (closes: #557989)
+
+ -- Andrew Pollock <apollock@debian.org>  Sun, 29 Nov 2009 12:33:49 -0800
+
 dstat (0.6.7-1) unstable; urgency=low
 
   * New upstream release
diff -u dstat-0.6.7/debian/control dstat-0.6.7/debian/control
--- dstat-0.6.7/debian/control
+++ dstat-0.6.7/debian/control
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Andrew Pollock <apollock@debian.org>
 Build-Depends: debhelper (>= 5.0.37.2)
-Build-Depends-Indep: python-central (>= 0.5), python-all-dev
+Build-Depends-Indep: python-central (>= 0.5), python-all-dev, dpatch
 Standards-Version: 3.7.3
 XS-Python-Version: current
 Homepage: http://dag.wieers.com/home-made/dstat/
diff -u dstat-0.6.7/debian/rules dstat-0.6.7/debian/rules
--- dstat-0.6.7/debian/rules
+++ dstat-0.6.7/debian/rules
@@ -11,6 +11,8 @@
 
 PACKAGE=dstat
 
+include /usr/share/dpatch/dpatch.make
+
 CFLAGS = -Wall -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -27,7 +29,7 @@
 	touch configure-stamp
 
 
-build: build-stamp
+build: build-stamp patch-stamp
 
 build-stamp: configure-stamp
 	dh_testdir
only in patch2:
unchanged:
--- dstat-0.6.7.orig/debian/patches/00list
+++ dstat-0.6.7/debian/patches/00list
@@ -0,0 +1 @@
+CVE-2009-3894
only in patch2:
unchanged:
--- dstat-0.6.7.orig/debian/patches/CVE-2009-3894.dpatch
+++ dstat-0.6.7/debian/patches/CVE-2009-3894.dpatch
@@ -0,0 +1,24 @@
+#! /bin/sh /usr/share/dpatch/dpatch-run
+## CVE-2009-3894.dpatch by  <apollock@debian.org>
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: Patch from Nico Golde to address CVE-2009-3894
+#
+# Description: Patch from Nico Golde to address CVE-2009-3894
+# Author: Nico Golde <nion@debian.org>
+# Bug: http://bugs.debian.org/557989
+# Forwarded: not-needed
+
+@DPATCH@
+diff -urNad dstat-0.6.7~/dstat dstat-0.6.7/dstat
+--- dstat-0.6.7~/dstat	2008-03-19 22:08:50.000000000 -0700
++++ dstat-0.6.7/dstat	2009-11-29 12:27:44.644944488 -0800
+@@ -28,8 +28,6 @@
+     inspath('/usr/local/share/dstat/')
+     inspath('/usr/share/dstat/')
+     inspath(os.path.abspath(os.path.dirname(sys.argv[0])) + '/plugins/')    # binary path + /plugins/
+-    inspath(os.getcwd() + '/plugins/')                                      # current path + /plugins/
+-    inspath(os.getcwd())                                                    # current path
+     inspath(os.path.expanduser('~/.dstat/'))                                # home + /.dstat/
+ except KeyboardInterrupt, e:
+     pass
